﻿//Clase usada para crear animaciones y transiciones vía ActionScript
import caurina.transitions.Tweener;
//Un método estático que permite ejecutar una función en un ámbito específico.
import mx.utils.Delegate;
//Clase que permite trabajar con datos en forma de pixeles de cada objeto Bitmap
import flash.display.BitmapData;
//Clase que crea una cámaras y ver el objecto desde algún punto de alrededor.
import org.papervision3d.cameras.*;
//Clase para crear texturas desde un bitmap guardado en libreria o externo
import org.papervision3d.materials.BitmapAssetMaterial;
//Clase con una lista de materiales para el objeto
import org.papervision3d.materials.*;
//Clase que permite crear y mostrar objectos en forma de rectángulo
import org.papervision3d.objects.Plane;
//Clase que permite crear una escena donde todos los objetos renderizados se encontrarán
import org.papervision3d.scenes.*;
//Clase que permite representar instancias de objectos 3D que son contenidos en la escena.
import org.papervision3d.core.proto.DisplayObject3D;
//Clase usada para crear y modificar objectos "rectángulo"
import flash.geom.Rectangle;
//Clase que representa una transformación de la matriz que determina la manera determinar puntos de una coordenada a otra
import flash.geom.Matrix;
//Clase que permite ajustar los valores de color en el objecto display
import flash.geom.ColorTransform;
//Se dispara un evento cada vez que ocurre un evento de ratón
import flash.events.MouseEvent;
// Clases para animación de objetos
import com.greensock.*;

//Clase NavegacionMagazine que se instanciada a través del MovieClip NavegacionMagazine
class NavegacionMagazine extends MovieClip{
	
	//Declaramos la variable scene instanciandole Scene3D
	var scene:Scene3D;
	//Declaramos variable privada llamada camara que instancia la clase Camera3D
	private var camera:Camera3D;
	//Declaramos la variable privada llamada container que tiene calidad de MovieClip
	private var container:MovieClip;
	//Declaramos la variable privada group que instancia a la clase DisplayObject3D
	private var group:DisplayObject3D;
	//Declaramos la variable privada objectArray la cual es una variable de tipo Arreglo
	private var objectArray:Array;
	//Declaramos la variable privada theimages la cual es una variable de tipo Arreglo
	private var theimages:Array;
	//Declaramos la variable privada target que instancia a la clase DisplayObjct3D
	private var target:DisplayObject3D;
	//Declaramos la variable privada numFotos que es de tipo númerica
	private var numFotos:Number;
	//Declaramos la variable privada numFotosLoaded que es de tipo númerica e igual a 0
	private var numFotosLoaded:Number = 0;
	//Declaramos la variable privada PI que es de tipo númerica con valor igual a 3.1415926
	private var PI:Number = 3.1415926;
	//Declaramos la variable privada thexml la cuál es una estructura XML
	private var thexml:XML;

	
	function NavegacionMagazine(){
		
		//Iniciamos la función init3D
		init3D();
		//cargamos la información de la estructura XML
		thexml = new XML();
		thexml.ignoreWhite = true;
		thexml.onLoad = Delegate.create(this, xmlLoaded);
		thexml.load("imagenes.xml");
		
		
	}

	//Se inicializa un contenedor y se coloca en la profundidad más alta en las posiciones x,y = 0
	function init3D()	{
		
		// Crear y centrar movieclip
		container = this.createEmptyMovieClip("container", this.getNextHighestDepth());
		container._x = 0;
		container._y = 0;

		// Crear escena
		scene = new MovieScene3D(container);

		// Crear cámara
		camera = new Camera3D();
		camera.z = -1000;
		camera.zoom = 1;
		camera.focus = 500;
	}

	function layoutFotos(){
		
		//Iteración para crear un bitmapData y entonces añadir cada nodo del xml en dicho movieclip en forma de imagen.
		for (var i = 0; i < numFotos; i++){
			//Declaración de variable foto equivalente al arreglo theimages[i]
			var foto = theimages[i];
			//Declaración de variable bmpdata la cual tiene definidos un ancho y alto relativo a foto
			var bmpdata:BitmapData = new BitmapData(foto._width, foto._height, false);
			//Dibujar el arreglo respectivo de foto
			bmpdata.draw(foto,new Matrix(),null,null,null,true);
			//Añadir material a bmpdata
			var bitmapMaterial:BitmapMaterial = new BitmapMaterial(bmpdata, true);
			bitmapMaterial.smooth = true;
			bitmapMaterial.oneSide = false;
			//Añadir bmpdata al movieclip borde ubicado en la raiz de la escena, nivel de profundidad 2
			_root.borde.attachBitmap(bmpdata,2);
			//Declaración de la variable material4 equivalante a un nuevo color hexadecimal con 80 grados alpha
			var material4 = new ColorMaterial(0xff0000, 80);
			//uno de los lados de material4 no se tomará en cuenta
			material4.oneSide = false;
			//Declaración de variable ESPACIO tipo numérica igual a 0
			var ESPACIO:Number = 0;
			//Declaración de variable ANCHO tipo numérica igual a 230
			var ANCHO:Number = 230;
			//Declaración de variable razonX tipo numérica igual a 1
			var razonX:Number = 1;
			//Declaración de variable razonY tipo numérica igual a 1
			var razonY:Number = 1;
			
			//Si el ancho de foto es mayor que su altura entonces 
			//la variable razonY es el cociente de dividir foto._height/foto._width
			//si es menor a la altura entonces
			//razonX es el cociente de dividir foto._width / foto._height
			if (foto._width > foto._height){
				
				razonY = foto._height / foto._width;
			}else{
				razonX = foto._width / foto._height;
			}
			
			//Se declara una variable llamada plane la cual es un nuevo Plano de la clase PV3D con un ancho igual al producto de
			//razonx por ANCHO, una altura igual al producto de razonY por ANCHO con 2 segmentos de profundidad en lo ancho y lo alto
			var plane:Plane = new Plane(bitmapMaterial, razonX * ANCHO, razonY * ANCHO, 2, 2);
			
			//Se declara j equivalente una iteración del valor i=0 sumando 1 cinco veces
			var j = i % 5;
			
			//Se declara k equivalente al cociente de i/5 redondeando al entero previo más cercano 
			var k = Math.floor(i / 5);
			
			//El valor del movieclip plane en x es equivalente a: (ANCHO + ESPACIO) * j - (ANCHO + ESPACIO) * 2;
			plane.x = (ANCHO + ESPACIO) * j - (ANCHO + ESPACIO) * 2;
			////El valor del movieclip plane en y es equivalente a: (ANCHO + ESPACIO) * k - ANCHO * 2 + ESPACIO;
			plane.y = (ANCHO + ESPACIO) * k - ANCHO * 2 + ESPACIO;
			//Empujar o introducir las dimensiones de plane a la escena
			scene.push(plane);
			
			//Se crea un movieclip para contener a plane.container
			var cont:MovieClip = plane.container;
			//Se ajusta una propiedad alpha del 50% de visibilidad al movieClip "cont"
			cont._alpha = 50;
			//Valores iniciales en el texto dinámico ecPlano
			_root.ecPlano.text = "x + y + z = 1";

			
			
		}
		
		
		//Valor de x en el movieClip camera es 1
		camera.x = 1;
		//Valor de y en el movieClip camera es 1
		camera.y = 1;
		
		//Se coloca el plano con valores en x,y = 1
		scene.renderCamera(camera);
		
		//Se ejecuta la función comienza con un retraso de 30 frames o 3 seg.
		TweenLite.delayedCall(30,comienza,[],this,true);
		
		
		function comienza(){
			
			//Se ejecuta de manera contínua la función loop3D
			this.onEnterFrame = loop3D;
			//Declaración de botonActual como variable que será usada dentro de la iteración para asignar cada uno de sus valores
			var botonActual;
			
			//Iteración de 29 triángulos para que en cada rollover que se haga sobre el id de triangulo se procede a detener el frame en la linea del tiempo relacionada con el "edo_"+i
			for(var i:Number = 1; i<= 29; i++){
				
				
				botonActual = _root.triangle["edo_"+i];
				botonActual.num = i;
				//Al hacer rollOver sobre botonActual se mostrará el frame "edo"+i del movieClip triangle ubicado en la raíz
				botonActual.onRollOver = function(){
					_root.triangle.gotoAndStop("edo_" + this.num);
					
				}
			
			}

		}
	}
	
	// _______________________________________________________________________
	//                                                                    Loop
	//Nos permite renderizar el plano siempre y cuando esté dentro de cierta área que ocupa el plano
	function loop3D(){
		
		// Render
		//Si el contendedor en lo horizontal es menor a -145 o mayor a 145 entonces no se realiza renderizado
		if(-container._xmouse <= -145 || -container._xmouse >= 145){
			
		}
		//Si el contendedor en lo vertical es menor a -145 o mayor a 145 entonces no se realiza renderizado
		else if (-container._ymouse >= 145 || -container._ymouse <= -145) {
			
		} 
		//Si está dentro del área entonces realiza renderizado
		else {
			
			camera.x = -container._xmouse * 2;
			camera.y = -container._ymouse * 2;
		}
	
		//Renderizar escena
		scene.renderCamera(camera);
		//Dejar vacío el campo de texto dinámico ecPlano ubicado en la raíz de la escena
		_root.ecPlano.text = "";

		
	}
	
	//Si la información del xml es cargada con éxito entonces añadir una imágen relacionada con el nodo del xml leído
	private function xmlLoaded(success)
	{
		//Declaramos la variable children equivalente a los nodos contenidos en thexml
		var children:Array = thexml.firstChild.childNodes;
		
		//Variable theimages de tipo arreglo
		theimages = new Array();
		//leemos el total de hijos de la estructura xml y lo asignamos a numFotos
		numFotos = children.length;
		
		for (var i = 0; i < numFotos; i++)
		{
			//Declaramos fotos equivalente al movieClip "foto"+i puesto en la profundidad más alta
			var foto = attachMovie("foto", "foto" + i, this.getNextHighestDepth());
			foto._visible = false;
			foto.loadFoto(children[i].attributes.src);
			foto.link = children[i].attributes.link;
		}

	}

	//Si todas las imágenes del xml has sido cargadas entonces ejecutar función layoutFotos
	private function onFotoLoaded(e)
	{
		theimages.push(e.target);
		//e.target._visible = false;
		numFotosLoaded++;
		//trace("foto loaded");
		if (numFotosLoaded == numFotos)
		{
			layoutFotos();
		}
	}
}